var Baker = require('baker'),
    mathBuild = require('glMath/build');
module.exports = new Baker({
	filename: 'graffiti',
	dirname: __dirname,
	starter: Baker.factory('glMath', mathBuild.source),
	header: ([
		'/**',
		' * graffiti.js - ',
		' * MIT License - (c) Roland Poulter 2011',
		' */'
	]).join('\n'),
	files: [
		'base/util',
		'base/WebGL',
		'base/Obj3d',
		'behavior/Shaded',
		'behavior/Movable',
		'behavior/Colored',
		'behavior/Boundary',
		'behavior/Animated',
		'behavior/Illuminated',
		'behavior/PolygonMesh',
		'behavior/ParticleField',
		'scene/Camera',
		'scene/World',
		'scene/Shader',
		'scene/Light',
		'scene/Entity',
		'scene/Material',
		'shaders/BasicShader',
		'materials/BasicMaterial',
		'shapes/Cube',
		'shapes/Cube2'
	]
}).uglify();