/*global module require*/
(function(){"use strict";
	function Movable () {return this.initMovable();}
	var util = require('../base/util'),
	    glMath = require('../glMath'),
	    movable = Movable.prototype,
	    Vector3 = glMath.require('Vector3'),
	    Matrix4 = glMath.require('Matrix4'),
	    Quaternion = glMath.require('Quaternion');
	Movable.check = function (obj) {
		return obj && obj.initMovable === movable.initMovable;
	};
	Movable.create = function (obj, args) {
		obj = obj || {};
		obj.initMovable = movable.initMovable || function () {
			this.transformation = new Matrix4().identity();
			this.rotation = new Vector3([0.0, 0.0, 0.0]);
			this.position = new Vector3([0.0, 0.0, 0.0]);
			this.scale = new Vector3([1.0, 1.0, 1.0]);
			return this;
		};
		obj.transform = function (fn) {
			util.safeApply(fn, this);
			return this.update();
		};
		obj.updateMoveable = function (parentTrans) {
			this.syncTransformation(parentTrans);
			return this.enumerate(function (obj) {
				if (Movable.check(obj)) {
					obj.update(this.transformation);
				}
			});
		};
		obj.syncTransformation = function (parentTrans) {
			if (parentTrans) {
				this.tranformation.set(parentTrans);
			} else {
				this.transformation.identity();
			}
			this.transformation.
				scale(this.scale).
				rotateX(glMath.degToRad(this.rotation[0])).
				rotateY(glMath.degToRad(this.rotation[1])).
				rotateZ(glMath.degToRad(this.rotation[2])).
				translate(this.position);
			return this;
		};
		obj.renderMovable = obj.syncTransformation;
		if (args) obj.init.apply(obj, args);
		return obj;
	};
	(module.exports = Movable).create(movable);
}).call(this);
