/*global module require*/
(function(){"use strict";
	var util = require('../base/util'),
	    Obj3d = require('../base/Obj3d'),
	    Movable = require('../behavior/Movable'),
	    Animated = require('../behavior/Animated');
	function Group (parent) {return this.initGroup(parent);}
	util.inherits(Group, Obj3d);
	var group = Group.prototype;
	Group.check = function (obj) {
		return Obj3d.check(obj) && obj.initGroup === group.initGroup;
	};
	Group.create = function (obj, args) {
		obj = obj || {};
		if (!Obj3d.check(obj)) Obj3d.create(obj);
		if (!Movable.check(obj)) Movable.create(obj);
		if (!Animated.check(obj)) Animated.create(obj);
		obj.initGroup = group.initGroup || function (parent) {
			this.initObj3d(parent);
			this.initMovable();
			this.initColored();
			return this;
		};
		obj.update = function () {
			this.updateMoveable();
			return this;
		};
		obj.render = function () {
			this.renderMoveable();
			return this.enumInvoke('render', [this.webgl, this.gl]);
		};
		if (args) obj.initGroup.apply(obj, args);
		return obj;
	};
	(module.exports = Group).create(group);
}).call(this);