/*global module require*/
(function(){"use strict";
	var util = require('../base/util'),
	    Obj3d = require('../base/Obj3d'),
	    Movable = require('../behavior/Movable'),
	    Colored = require('../behavior/Colored'),
	    Animated = require('../behavior/Animated'),
	    Illuminated = require('../behavior/Illuminated');
	function Light (parent) {return this.initLight(parent);}
	var light = Light.prototype;
	util.inherits(Light, Obj3d);
	Light.check = function (obj) {
		return Obj3d.check(obj) && obj.initLight === light.initLight;
	};
	Light.create = function (obj, args) {
		obj = obj || {};
		if (!Obj3d.check(obj)) Obj3d.create(obj);
		if (!Movable.check(obj)) Movable.create(obj);
		if (!Animated.check(obj)) Animated.create(obj);
		if (!Colored.check(obj)) Colored.create(obj);
		if (!Illuminated.check(obj)) Illuminated.create(obj);
		obj.initLight = light.initLight || function (parent) {
			this.initObj3d(parent);
			this.initMovable();
			this.initColored();
			return this;
		};
		if (args) obj.initLight.apply(obj, args);
		return obj;
	};
	(module.exports = Light).create(light);
}).call(this);