/*global module require Uint8Array Float32Array*/
(function(){"use strict";
	var util = require('../base/util'),
	    Entity = require('../scene/Entity'),
	    BasicMaterial = require('../materials/BasicMaterial');
	function Cube2 (world) {return this.initCube2(world);}
	util.inherits(Cube2, Entity);
	var cube2 = Cube2.prototype;
	Cube2.check = function (obj) {
		return Entity.check(obj) && obj.initCube2 === cube2.initCube2;
	};
	Cube2.create = function (obj, args) {
		var supr = Entity.prototype;
		obj = obj || {};
		if (!Entity.check(obj)) {
			Entity.create(obj);
		}
		obj.initCube2 = cube2.initCube2 || function (parent, material) {
			material = material || new BasicMaterial(parent.world);
			return this.initEntity(parent, material).allocate();
		};
		obj.allocate = function () {
			var uvData = [//uv square
				[ 0.0, 1.0], [ 1.0, 1.0],
				[ 1.0, 0.0], [ 0.0, 0.0]
			];
			return this.polygonMeshFromJSON({
				vertices: [
					//back
					[-1.0,-1.0,-1.0],//v0
					[ 1.0,-1.0,-1.0],//v1
					[ 1.0, 1.0,-1.0],//v2
					[-1.0, 1.0,-1.0],//v3
					//front
					[-1.0,-1.0, 1.0],//v4
					[ 1.0,-1.0, 1.0],//v5
					[ 1.0, 1.0, 1.0],//v6
					[-1.0, 1.0, 1.0] //v7
				],
				surfaces: [
					{polygons: [//cap
						{vertices: [0, 1, 2, 3], groups: {uv: uvData, color: [1.0, 0.0, 0.0, 1.0]}}
					]},
					{polygons: [//body
						{vertices: [0, 1, 4, 5], groups: {uv: uvData, color: [0.0, 1.0, 0.0, 1.0]}},
						{vertices: [1, 2, 6, 5], groups: {uv: uvData, color: [0.0, 1.0, 1.0, 1.0]}},
						{vertices: [2, 3, 7, 6], groups: {uv: uvData, color: [1.0, 1.0, 0.0, 1.0]}},
						{vertices: [3, 0, 4, 7], groups: {uv: uvData, color: [1.0, 0.0, 1.0, 1.0]}}
					]},
					{polygons: [//cap
						{vertices: [4, 5, 6, 7], groups: {uv: uvData, color: [0.0, 0.0, 1.0, 1.0]}}
					]}
				],
				groups: {materials: []}
			});
		};
		obj.dellocate = function () {
			this.emptyPolygonMesh();
			return this;
		};
		if (args) obj.initCube2.apply(obj, args);
		return obj;
	};
	(module.exports = Cube2).create(Cube2.prototype);
}).call(this);